/***************************************************************************
                          daemon.h  -  description
                             -------------------
    begin                : Sat Sep 29 2001
    copyright            : (C) 2001 by Gav Wood
    email                : gav@indigoarchive.net
 ***************************************************************************/

#ifndef __DAEMON
#define __DAEMON

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#pragma interface

namespace sucs
{

class Daemon
{
protected:
	virtual int RunProgram() = 0;

public:
	// Daeminises the current process then runs the derived program.
	void Daemonise();

	// Does nothing except run the derived program.
	void DontDaemonise() { exit(RunProgram()); }

	Daemon();
	virtual ~Daemon();
};

}

#endif
