//
// C++ Interface: signallistener
//
// Description:
//
//
// Author: Gav Wood <gav@indigoarchive.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef _SUCS_SIGNALLISTENER_H
#define _SUCS_SIGNALLISTENER_H

#include <vector>
#include <map>
using namespace std;

namespace sucs
{

/**
@author Gav Wood
*/

//TODO: Make thread-safe!!!

class SignalHandler;

class SignalListener
{
	multimap<int, SignalHandler *> theHandlers;
	
	static SignalListener *theOne;
	
	friend void actualHandler(int signal = 0);

	friend class SignalHandler;
	void set(int signal, SignalHandler *handler);
	void reset(int signal, SignalHandler *handler);
	
public:
	static SignalListener *signalListener() { if(theOne) return theOne; return (theOne = new SignalListener); }
	
	void ignore(int signal);
	
	SignalListener();
	~SignalListener();
};

};

#endif
